require 'sketchup'

module RTK

def self.multi_face_offset()

sel = Sketchup.active_model.selection

width = UI.inputbox(["偏移量"],[],[],"偏移距离")

Sketchup.active_model.start_operation""

sel.each {|e|
 if e.is_a? Sketchup::Face
 e.offset(-(width[0].to_l))
 end
}

Sketchup.active_model.commit_operation

end#method

end#module

UI.menu("Plugins").add_item("多面偏移") { RTK.multi_face_offset }

    # 以下部分是添加图标的代码
    toolbar = UI::Toolbar.new "多面偏移"
    cmd = UI::Command.new("多面偏移") { RTK.multi_face_offset }
    cmd.tooltip = "多面偏移"
    cmd.status_bar_text = '同时偏移多个选中的面。'
    cmd.small_icon = "/Multi Face Offset/icon.png"
    cmd.large_icon = "/Multi Face Offset/icon.png"
    toolbar = toolbar.add_item cmd
    toolbar.show
    puts cmd.large_icon
    # 以上部分是添加图标的代码


class Sketchup::Face
	def offset(dist)
begin
		pi = Math::PI
		if (not ((dist.class==Fixnum || dist.class==Float || dist.class==Length) && dist!=0))
			return nil
		end
		verts=self.outer_loop.vertices
		pts = []
		
		# CREATE ARRAY pts OF OFFSET POINTS FROM FACE
		
		0.upto(verts.length-1) do |a|
			vec1 = (verts[a].position-verts[a-(verts.length-1)].position).normalize
			vec2 = (verts[a].position-verts[a-1].position).normalize
			vec3 = (vec1+vec2).normalize
			if vec3.valid?
				ang = vec1.angle_between(vec2)/2
				ang = pi/2 if vec1.parallel?(vec2)
				vec3.length = dist/Math::sin(ang)
				t = Geom::Transformation.new(vec3)
				if pts.length > 0
					vec4 = pts.last.vector_to(verts[a].position.transform(t))
					if vec4.valid?
						unless (vec2.parallel?(vec4))
							t = Geom::Transformation.new(vec3.reverse)
						end
					end
				end
				
				pts.push(verts[a].position.transform(t))
			end
		end

		# CHECK FOR DUPLICATE POINTS IN pts ARRAY

		duplicates = []
		pts.each_index do |a|
			pts.each_index do |b|
				next if b==a
				duplicates<<b if pts[a]===pts[b]
			end
			break if a==pts.length-1
		end
		duplicates.reverse.each{|a| pts.delete(pts[a])}

		# CREATE FACE FROM POINTS IN pts ARRAY

		(pts.length > 2) ? (parent.entities.add_face(pts)) : (return nil)

rescue
	puts "#{self} 没有偏移: #{pts}"
	return nil
end
	end
end